小孩学Python(19):相当

例5

#define function
def test_func( level ):
    if level < 1:
        raise Exception("Invalid level!", level)

try:
    #invoke function
    test_func(0)                
except "any":
    print 1
else:
    print 2
finally:
    print 3

运行结果:

3
Traceback (most recent call last):
  File “test.py”, line 8, in <module>
test_func(0)
  File “test.py”, line 4, in test_func
raise Exception(“Invalid level!”, level)
Exception: (‘Invalid level!’,0)

从运行结果可以看看,raise抛出异常后,except和else中的语句都不曾被打印出来,不过finally中的语句被打印出来了。

四、try…except…finally语句

finally 中的代码无论是否爆发特别都将被实施

例2

将mytest文件的写权限去掉

chmod -w mytest

再次实施test.py,结果为

Error: 
Error: No file found or read file error!

例1

try:
    fh = open("mytest", "w")
    fh.write("This is a file to test exception!")
except IOError:
    print "Error: No file found or read file error!"
else:
    print "Write cotent to file succeed!"
fh.close()

运作结果:

This is a file to test exception!

翻看mytest文件中的内容:

This is a file to test exception

二、非凡处理

捕捉分外可以接纳try…except语句。
try…except语句用来检测try语句块中的错误,从而让except语句捕获非常消息并处理。
万一您不想在老大发生时截至你的程序,只需在try里捕获它。

语法:
以下为简便的try….except…else的语法

try:
<语句>        #运行别的代码
except <名字>:
<语句>        #如果在try部份引发了'name'异常
except <名字>,<数据>:
<语句>        #如果引发了'name'异常,获得附加的数据
else:
<语句>        #如果没有异常发生

try的行事规律是,超越导一个try语句后,python就在眼前先后的上下文中作标志,这样当相当出现时就足以回到那里,try子句先实施,接下去会生出如何看重于履行时是否出现非常。

假如当try后的口舌执行时发出特别,python就跳回到try并实施第一个相当该特其它except子句,相当处理完毕,控制流就因而一切try语句(除非在处理非常时又引发新的要命)。

假若在try后的口舌里发生了异常,却没有匹配的except子句,极度将被递交到上层的try,或者到程序的最上层(这样将竣工程序,并打印缺省的失误信息)。

倘若在try子句执行时没有发出非凡,python将执行else语句后的言语(即使有else的话),然后决定流通过任何try语句。

三、使用except而不带其他万分类型

您可以不带其他相当类型使用except

try:
    正常的操作
   ......................
except:
    发生异常,执行这块代码
   ......................
else:
如果没有异常执行这块代码

上述措施try…except语句捕获所有发生的特别。但这不是一个很好的不二法门,我们无法经过该程序识别出切实的分外音讯。因为它擒获所有的分外。

一、什么是卓殊

特别即是一个风波,该事件会在程序执行过程中生出,影响了程序的正常履行。
一般景色下,在Python无法正常处理程序时就会发出一个要命。
不行是Python对象,表示一个破绽百出。
当Python脚本暴发特别时我们需要捕获处理它,否则程序会终止执行。

例3:除0异常

try:
    1 / 0
except Exception as e:
    print "0 can not be divided!"
else:
    print "No exception!"
finally:
    print "Anyway, statement in finally block will be executed!"

运行结果:

0 can not be divided!
Anyway, statement in finally block will be executed!

五、raise触发相当